
typedef struct ls_tile_inf{
unsigned char passable;
unsigned char range_penalty;
unsigned short gr_light;
short int light_str;
unsigned char ls_light;
}ls_tile_inf;


typedef struct swad_inf{
unsigned int offset,offset2;
int sx,sy;
}swad_inf;

typedef struct pic_inf{
int *swadn;
}pic_inf;

typedef struct ani_inf{
char state,ffgrid;  //1=free from grid
int pos,pic,cnt,cnt_max,div,yh,wpic,mpic,ontop_fly,tp;
int type;
float px,py,vx,vy;
}ani_inf;


typedef struct crt_spawner_inf{
char state;
char x,y;
char range;
int crt_type[20];
int crt_level[20];
int item_type[5];
int item_chnc[5];
int sts[25]; //other stats
             //0 = spawner ID
}crt_spawner_inf;




typedef struct skill_inf{
char state;
int type; //type of skill (eg heal,lightning, fireball, summon wolf etc)
int sellect_type; //eg enemy or ally,block, ranged or in walking distance etc
int range;  //can be range of ally/enemy or walking distance etc
int lev; //the level of the skill (starts at level 1)
int num_casts; //how many times the skill has been used in the current battle
int lim_casts; //the maximum number of times the spell can be cast per battle
               //set at the begining of the battle and remaining unchanged
int passive;     //1= skill is passive ie does appear in battle skills list
}skill_inf;

typedef struct rqst_inf{
int state;
int rtype;        //type of question -0=normal question (it can only be asked once), 
                  //                  1=buy/sell, 
                  //                  2=death threat,
                  //                  3=join in to kill
                  //                  4=join in to help
                  //                  5=impatial response to battle start
                  //                  6=impulsive request (ie he'll just say it as soon as he can)

int con;   //condition that must be true for the request to be available
int qt,qn;        //text of question
int at,an;        //text of answer
int t_str,t_end; //what time of day this can be said
int a[4]; //which things must already have been said (ands)
int o[4]; //which things must already have been said (ors)
int c[4]; //things that are deactivated after this has been said
int opmod; //how his opinion of you changes when this is said;
int op_a,op_b; //opinion of you must be >=op_a and <=op_b
}rqst_inf;

typedef struct npc_spch_inf{
int grtt[5];
int grtn[5];
int sellt;
int selln;
int snum;

rqst_inf rqst[100];

}npc_spch_inf;


typedef struct npc_inf{
char nam[25];
int state;
int level;
int hp,mana;
int type;
int exp;
int gold;
int dead;
int disappear_cnt;
short int items_for_sale[20];
short int item_seed[20];
int ooy; //opinion of your character
int face;
int lev,px,py; //starting position and level/area
int crtn;
int p1crn;
char p1cr_type; //0=nothing,
                //1=temp p1cr to be deleted at end of battle,
                //2=party p1cr (actually in the party
                //3=was in the party at one stage so p1cr is permenant
char ss[100];  //0=still to be said 1=has been said 2=has been canceled
}npc_inf;


typedef struct p1cr_inf{
char nam[25];
int state;
int level;
int hp,mana;
int type;
int face;
int exp;
int crtn;  //This is the n of the real creature (below) that belongs to these stats
int pinf[100];
int PEN; //equiped item stats
// 0 = which battle skill is sellected
// 1 = showing skills or useable items
// 2 = num of items that can be used in a battle
// 3 = which item slot is sellected
// 4 = if an item has already been used this round then =1 else =0
// 5 = how far down the out-of-battle skills list
// 6 = how many to move down/up (after arrows are clicked)
// 7 = count for moving up/down
// 8 = skill points remaining
// 9 = old level (used when going up a level)
// 10 = skill points recieved (used when going up a level)
// 11 = number of attribute points
// 12 = strength 0
// 13 = strength 1
// 14 = agility 0
// 15 = agility 1
// 16 = dexterity 0
// 17 = dexterity 1
// 18 = constitution 0
// 19 = constitution 1
// 20 = intelligence 0
// 21 = intelligence 1

int bat_it[16]; //battle items -1 = none in slot
skill_inf bat_sk[50]; //battle skills
//skill_inf pas_sk[16]; //skills that are not directly used in battle ie passive
char eqp_com[25];
int eqp[25];          //0=sword
                      //1=bow
                      //2=spear
                      //3=axe
                      //4=shield
                      //5=boots
                      //6=gauntlets
                      //7=helm
                      //8=belt
                      //9=amulets
                      //10=ring,ring 2
                      //11= NOTHING! (but used for ring 2...)
                      //12=leather
                      //13=chain mail
                      //14=plate mail


}p1cr_inf;

typedef struct item_inf{
char state;
char nam[25];
int user;  //who is using the item(p1cr) -1=no one
int cata;  //catagory 1=wearable, 2=useable (eg potion)
int type;  //if wearable, 0 =sword, 1=bow etc
int ww;  //where the item belongs 
         //0=in inventory, 
         //1=EN item,
         //2=temp npc item , 
         //3=temp chest item 
         //4=PEN item, 
         //5=special attack items and items created by npcs that are not in the party
char npcin; //for items created by npcs to be bought it is which slot the item came from


int pic;
int cost;
int seed; //item seed
int witem; //what item (ie in.txt)
int unique; //0=item is not unique and can be changed into a type-seed item 1=item is unique and can't
                     // Wearables                //useables
                     
short int ats[100];  //0=weight                  //weight
                     //1=P.Dam increase          //1=can/cant be used out of battle
                     //2=P.Dam %increase         //2= 1=used on allies, 2=used on enemies
                     //3=F.Dam increase          //3= type if stackable (0=not stackable)
                     //4=F.Dam %increase         //4= number if stackable
                     //5=W.Dam increase          //5= mouse pick to show if being carried
                     //6=W.Dam %increase         //6= item type to spawn when used
                     //7=E.Dam increase          //7= hp restored
                     //8=E.Dam %increase         //8= %hp restored
                     //9=A.Dam increase          //9= status effect to cure (-1)=none
                     //10=A.Dam %increase        //10= status effect to cause
                     //11= +AC                   //11= duration of status effect
                     //12= +F.res                //12= mp restored 
                     //13= +W.res                //13= m p %restored 
                     //14= +E.res
                     //15= +A.res
                     //16= +Luck
                     //17= +dodge
                     //18= +speed
                     //19= HP max increase
                     //20= HP max %increase
                     //21= slow             (chance to cause on attack)
                     //22= blind
                     //23= fatigue
                     //24= broken armour
                     //25= burns
                     //26= frozen
                     //27= crushed
                     //28= shaken
                     //29= poison
                     //30= forgetfulness
                     //31= Accuracy
                     //32= heal adj allies (x% of current hp)
                     //33= x% chance to cure bad stts of adj allies
                     //34= haste
                     //35= precision
                     //36= alert
                     //37= stone skin
                     //38= fire blessing
                     //39= water blessing
                     //40= earth blessing
                     //41= air blessing
                     //42= regen
                     //43= concentration
                     //44= critical blow
                     //45= amount added to wound limit
                     //46= poison strength
                     //47= exp increase
                     //48= mana MAX increase
                     //49= mana MAX %increase
                     //50= added to strength
                     //51= added to agility
                     //52= added to dexterity
                     //53= added to constitutuib
                     //54= added to intelligence


                     

}item_inf;

typedef struct istack_inf{
int I[200];
}istack_inf;

typedef struct crtr_inf{
char pxmod,pymod;  ///position modifiers
char wdir;        ///direction walking in (0=no-where,1=L,2=R,3=U,4=D)
char fdir;        ///1=right else left
char ani;         ///animation stage
char state;
char vis; //1=visable, 0= invisable

int npcn; //which npc the creature belongs to
int p1crn; //which p1cr the creature belongs to

int drst[6];       //style when drawing
char trn;         //has or has not had turn in the round yet
int px,py;
int atkc;      //creature to attack
float atk_cnt;  //count when attacking
char dr_md; //draw miss/dodge
char dr_dc[10]; //draw damage count
int dr_dam[10]; //draw damage amount
int dr_dcol[10];//colour of txt
int dead_cnt;
int dr_hp;  //count for drawing/fading hp bar

int cr_path[25];   //creature path
int p_stage;       //path stage
float d_b_sq;      //distance between squares
int csq;  ///which square to draw the creature on
unsigned int ani_cnt;  //animation count
char rng_pen; //penalty due to obsticles for ranged attacks
int EN;
int eqp[15];

int type;
int pic; //which is first pic
int team; //1= your own 2=enemy 3=ally
int lev[2],mlev[2];
int prty[3];  //priority when starting: the higher this is the closer to starting the creature will be,
              //this also effects the creatures chance to resist spells such as hypnotise
int hp,mana;
int hp_max[3];   //not reduced by low mlev
int wnd_lim[3];
int F_dam[3];
int W_dam[3];
int E_dam[3];
int A_dam[3];
int P_dam[3];
int AC[3];
int F_res[3];
int W_res[3];
int E_res[3];
int A_res[3];
int acc[3];
int ddg[3];
int lck[3];
int movem[3];
int mana_max[3];

int spec;
int rorm;
int rng;
int sht_t;
int fly;

int stts[25];         //status effects
/*
//[0]=slow            //movement+=50%
//[1]=haste           //extra movement
//[2]=blind           //half acc
//[3]=precision       // acc=100
//[4]=fatigued        //ddg=0
//[5]=alert           //ddg*=2
//[6]=broken armour   //AC=0
//[7]=stone skin      //AC+=20
//[8]=burns           //receive 30% of damage dealt (in f_dam) during an attack (attacker's AC is ignored and he has no chance to dodge)
//[9]=Fire blessing   //fire dam += 15% of total dam,+ 30 fire res
//[10]=frozen         //receive 30% of damage dealt (in w_dam) during an attack (attacker's AC is ignored and he has no chance to dodge)
//[11]=Water blessing //water dam += 15% of total dam,+ 30 water res
//[12]=crushed         //receive 30% of damage dealt (in e_dam) during an attack (attacker's AC is ignored and he has no chance to dodge)
//[13]=Earth blessing //earth dam += 15% of total dam,+ 30 earth res
//[14]=Shaken         //receive 30% of damage dealt (in a_dam) during an attack (attacker's AC is ignored and he has no chance to dodge)
//[15]=Air blessing   //air dam += 15% of total dam,+ 30 air res
//[16]=Poison         //lose [22]% of hp max at end of round
//[17]=Regen         //gain 10% of hp max at end of round
//[18]=high risk      //half AC,half ddg,half acc,tripple P_dam
//[19]=low risk       //AC+20,double ddg,100 acc,half P_dam
//[20]=forgetfulness  //35% chance of skipping a turn
//[21]=concentration  //35% chance of having a second turn
//[22]=poison strength //this is what % of hp is lot when poisoned (reduces by 1 reach round like all stts)
///////These take effect in : Update_stats(CRTR3),do_attack(CRTR3),new_turn(CRTR2),find_turn(CRTR1)-forget,cocentrate
*/

int mag[50]; //these are magic parameters (eg turned into a frog etc)
//[0]=if(>0) creature is entangled (ie speed = 0)
//[1]=entangle damage (physical damage recieved by creature at the end of each round
//[2]=HYPNOTISED
//[3]=MAGIC SHIELD
//[4]=Elemental enchantment - rounds remaining
//[5]=Elemental enchantment - str
//[6]=turned into a frog/fly (rounds remaining)
//[7]=percentage damage is reduced by as a result of the above
//[8]=creatures original pic
//[9]=creatures original rorm
//[10]= when=1 and [6]==0 change creature back to normal
}crtr_inf;

typedef struct chest_inf{
char state;
int lev;
int px,py;
int pic;                 //which ls to draw as the chest ls[pic+1] id the chest when open
short int item[20];      //item type
short int item_seed[20]; //item seed
unsigned char item_chnc[20];
char trap_state;     //0=open,1=locked,2=jammed (ie all driscs to 100%)
int discs;
int trap_diff; //trap difficulty
int trap_seed;
int side; //which side of box opens (1=L,2=R,3=U,4=D)
char drisk[8];
}chest_inf;



